<?php
/**
 * @package VirtueMart
 * @subpackage payment
 * @author CM-S.ru
 * @copyright Copyright (C) 2012-2014 CM-S.ru. All rights reserved.
 * @license GNU General Public License version 2 or later
 */

defined('_JEXEC') or die;

if (!class_exists('vmPSPlugin')) {
	require(JPATH_VM_PLUGINS.DS.'vmpsplugin.php');
}

class plgVMPaymentCash24 extends vmPSPlugin
{
	function __construct($subject, $config)
	{		
		parent::__construct($subject, $config);

		$jlang = JFactory::getLanguage();
		$jlang->load('plg_vmpayment_cash24', JPATH_ADMINISTRATOR, NULL, TRUE);
		
		$this->_loggable = true;
	
		$this->_tablepkey = 'id';
		$this->_tableId = 'id';
		$varsToPush = array(
			'status_create' => array('', 'char'),
			'status_hold' => array('', 'char'),
			'status_success' => array('', 'char'),
'status_canceled' => array('', 'char'),
	'status_refunded' => array('', 'char'),	
	'methodname' => array('', 'char')	
		);
		
		$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
		
	}

    public function getVmPluginCreateTableSQL()
	{
		
    }

	

	function plgVmConfirmedOrder($cart, $order)
	{
		if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
	   		return null; // Another method was selected, do nothing
		}

		if (!$this->selectedThisElement($method->payment_element)) {
	    	return false;
		}
		
		$session = JFactory::getSession();
		$return_context = $session->getId();
		$this->_debug = $method->debug;
		$order_number = $order['details']['BT']->order_number;
		$this->logInfo('plgVmConfirmedOrder order number: '.$order_number, 'message');

		if (!class_exists('VirtueMartModelOrders')) {
			require(JPATH_VM_ADMINISTRATOR.DS.'models'.DS.'orders.php');
		}
		
		if (!class_exists('VirtueMartModelCurrency')) {
			require(JPATH_VM_ADMINISTRATOR.DS.'models'.DS.'currency.php');
		}

		if (!class_exists('TableVendors')) {
    		require(JPATH_VM_ADMINISTRATOR.DS.'table'.DS.'vendors.php');
		}
		
		$vendorModel = VmModel::getModel('Vendor');
		$vendorModel->setId(1);
		$vendor = $vendorModel->getVendor();
		$vendorModel->addImages($vendor, 1);
		$this->getPaymentCurrency($method);
		$currency_code_3 = shopFunctions::getCurrencyByID($method->payment_currency, 'currency_code_3');

		$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
		$totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, false), 2);
		$cd = CurrencyDisplay::getInstance($cart->pricesCurrency);
		
		if ($totalInPaymentCurrency <= 0) {
			vmInfo(JText::_('PLG_ONPAY_VM2_ERROR_1'));
			return false;
		}

		
		
		$virtuemart_paymentmethod_id = $order['details']['BT']->virtuemart_paymentmethod_id;
		
		$dbValues['order_number'] = $order_number;
		$dbValues['payment_name'] = $this->renderPluginName($method, $order);
		$dbValues['virtuemart_paymentmethod_id'] = $cart->virtuemart_paymentmethod_id;
		$dbValues['onpay_custom'] = $return_context;
		$dbValues['cost_per_transaction'] = $method->cost_per_transaction;
		$dbValues['cost_percent_total'] = $method->cost_percent_total;
		$dbValues['payment_currency'] = $method->payment_currency;
		$dbValues['payment_order_total'] = $totalInPaymentCurrency;
		$dbValues['tax_id'] = $method->tax_id;
		$this->storePSPluginInternalData($dbValues);
		
		$return_url = substr(JURI::root(false, ''), 0, -1).JROUTE::_('index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived', false);
		$fail_url = substr(JURI::root(false, ''), 0, -1).JROUTE::_('index.php?option=com_virtuemart&view=pluginresponse&task=pluginUserPaymentCancel', false);
		$price_final = $method->price_final ? 'true' : 'false';
		$add_params = trim($method->add_params, '&');
		$total_md5 = $this->to_float($totalInPaymentCurrency);
		$md5check = md5('fix;'.$total_md5.';'.$currency_code_3.';'.$order_number.';yes;'.$secret_word);
		$user_email = $order['details']['BT']->email;
		$design = $method->design;
		
		$lang = '';
		if ($method->lang) {
			$lang = '&ln='.$method->lang;
		}
		$callback="http://".$_SERVER['HTTP_HOST']."/plugins/vmpayment/cash24/cash24_notify.php";
		$id=VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);
		$time = time() + 24 * 60 * 60;
		$exptime=gmdate('Y-m-d', $time) . 'T' . gmdate('H:i:s', $time);
		
$arParams = array();
$arParams['amount']=$totalInPaymentCurrency;
$arParams['currency']=$currency_code_3;
$arParams['email']=$user_email;
$arParams['description']='Order #'.$id;
$arParams['order']=$id;
$arParams['success']=$return_url;
$arParams['cancel']=$fail_url;
$arParams['callback']=$callback;
$arParams['method']=$method->methodname;
if($order['details']['BT']->phone_2 != ''){
$arParams['phone']=$order['details']['BT']->phone_2;
}
$arParams['wallet']='';
$arParams['expires']=$exptime;
if ($this->params->get('command_key')=='' OR $this->params->get('merchant_id')=='') {
	    	die('Missing ID or KEYs');
		}

function createInvoice($arParams,$auth,$key)
	{
		$auth = $auth;
		$commandSecretKey = $key;

		$request = '';
		$toSign = 'create-invoice';
		foreach ($arParams as $key => $val)
		{
			$request .= "<$key>" . $val . "</$key>\r\n";
			if ($key != 'expires' AND $key != 'phone')
				$toSign .= '-' . $val;
		}

		$sign = md5($toSign . '-' . $commandSecretKey);

		$xml = '
			<?xml version="1.0" encoding="utf-8"?>
			<cash24 xmlns="http://api.cash24.ru/1.0/">
			  <request xmlns="http://api.cash24.ru/1.0/create-invoice/">
				' . $request . '
			  </request>
			  <envelope>
				<auth>' . $auth . '</auth>
				<sign>' . $sign . '</sign>
			  </envelope>
			</cash24>
		';

		return trim($xml);
	}
$headers = array(
    "Content-type: text/xml"
    
);
$k= createInvoice($arParams,$this->params->get('merchant_id'),$this->params->get('command_key'));
$respurl="https://api.cash24.ru/1.0/";
		 $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $respurl);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER,true);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_POSTFIELDS, $k);
	curl_setopt($curl, CURLOPT_HTTPHEADER, $headers );
	 
	curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
    $out = curl_exec($curl);
	
if(empty($out)){
echo "Incorrect request,check URL";
exit;
}		
	$url = new SimpleXMLElement($out);
	
    curl_close($curl);
		$turl= $url;
		$url = $url->response->url; //формируем строку url

		if(!empty($turl->envelope->error)){
		echo $turl->envelope->text;
		exit;
		}
if (empty($url)) {
	    	echo "Incorrect ID or KEYs";
			exit;
		}
		$html = '<html><head><title>Redirection</title></head><body><div style="margin: auto; text-align: center;">';
		$html .= '<form action="'.$url.'" method="get" name="vm_onpay_form">';
		$html .= '<h2>Подождите, идет перенаправление на Cash24.ru</h2>';
		$html .= '</form></div>';
		$html .= '<script type="text/javascript">';
		$html .= 'document.vm_onpay_form.submit();';
		$html .= '</script></body></html>';
		
		$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);
		$modelOrder = VmModel::getModel('orders');
		$order['customer_notified'] = 1;
		$order['order_status'] = $method->status_create;
		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);
		
		$cart->_confirmDone = false;
		$cart->_dataValidated = false;
		$cart->setCartIntoSession();
		JRequest::setVar('html', $html);
		
	}
	
	function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, $paymentCurrencyId)
	{
		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
	    	return null; // Another method was selected, do nothing
		}
			
		if (!$this->selectedThisElement($method->payment_element)) {
	    	return false;
		}

		$this->getPaymentCurrency($method);
		$paymentCurrencyId = $method->payment_currency;
	}
	

    function plgVmOnPaymentResponseReceived($html)
	{
		if (!class_exists('VirtueMartCart')) {
			require(JPATH_VM_SITE.DS.'helpers'.DS.'cart.php');
		}
		
		if (!class_exists('shopFunctionsF')) {
			require(JPATH_VM_SITE.DS.'helpers'.DS.'shopfunctionsf.php');
		}
		
		if (!class_exists('VirtueMartModelOrders')) {
			require(JPATH_VM_ADMINISTRATOR.DS.'models'.DS.'orders.php');
		}
		$cart = VirtueMartCart::getCart();
		$cart->emptyCart();
		$virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);
		$order_number = JRequest::getString('on', 0);
		
		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
	    	return null;
		}
		
		if (!$this->selectedThisElement($method->payment_element)) {
	    	return null;
		}
		
		if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number))) {
			return null;
		}
		
		if (!($paymentTable = $this->getDataByOrderId($virtuemart_order_id))) {
			return '';
		}
		
		$payment_name = $this->renderPluginName($method);
		$html = $this->_getPaymentResponseHtml($paymentTable, $payment_name);

	
		
		return true;
	}

    function plgVmOnUserPaymentCancel()
	{
		if (!class_exists('VirtueMartModelOrders')) {
	    	require(JPATH_VM_ADMINISTRATOR.DS.'models'.DS.'orders.php');
		}
		
		$order_number = JRequest::getString('on', '');
		$virtuemart_paymentmethod_id = JRequest::getInt('pm', '');
		
		if (empty($order_number) or empty($virtuemart_paymentmethod_id) or !$this->selectedThisByMethodId($virtuemart_paymentmethod_id)) {
			return null;
		}
		
		if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number))) {
			return null;
		}
		
		if (!($paymentTable = $this->getDataByOrderId($virtuemart_order_id))) {
			return null;
		}

		VmInfo(JText::_('VMPAYMENT_PAYPAL_PAYMENT_CANCELLED'));
		
		$session = JFactory::getSession();
		$return_context = $session->getId();
		
		if (strcmp($paymentTable->onpay_custom, $return_context) === 0) {
			$this->handlePaymentUserCancel($virtuemart_order_id);
		}
		
		return true;
	}
	
	//функция выдает ответ для сервиса onpay в формате XML на чек запрос 
	function answer($type, $code, $pay_for, $order_amount, $order_currency, $text, $secret_word)
	{
		$md5 = strtoupper(md5("{$type};{$pay_for};{$order_amount};{$order_currency};{$code};".$secret_word)); 
		
		return "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<result>\n<code>{$code}</code>\n<pay_for>{$pay_for}</pay_for>\n<comment>{$text}</comment>\n<md5>{$md5}</md5>\n</result>";
	}
	
	//функция выдает ответ для сервиса onpay в формате XML на pay запрос 
	function answerpay($type, $code, $pay_for, $order_amount, $order_currency, $text, $onpay_id, $secret_word)
	{
		$md5 = strtoupper(md5("{$type};{$pay_for};{$onpay_id};{$pay_for};{$order_amount};{$order_currency};{$code};".$secret_word)); 
	
		return "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<result>\n<code>{$code}</code>\n<comment>{$text}</comment>\n<onpay_id>{$onpay_id}</onpay_id>\n<pay_for>{$pay_for}</pay_for>\n<order_id>{$pay_for}</order_id>\n<md5>{$md5}</md5>\n</result>"; 
	}
	
    function plgVmOnPaymentNotification()
	{
	
		if (!class_exists('VirtueMartModelOrders')) {
	    	require(JPATH_VM_ADMINISTRATOR.DS.'models'.DS.'orders.php');
		}

		$payment = JRequest::get('post');
		
		if (!isset($payment['order'])) {
		  
	    	return false;
		}
		
		$virtuemart_order_id = $payment['order'];
		
		
		$modelOrder = new VirtueMartModelOrders();
        $order_info   = $modelOrder->getOrder($virtuemart_order_id);
		 $payments      = $this->getDataByOrderId($virtuemart_order_id);
		 $test=$this->getVmPluginMethod($order_info['details']['BT']->virtuemart_paymentmethod_id);
		 $method       = $this->getVmPluginMethod($payments->virtuemart_paymentmethod_id);
		  if (!$method->payment_currency)
            $this->getPaymentCurrency($method);
        // END printing out HTML Form code (Payment Extra Info)
        $q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
        $db =& JFactory::getDBO();
        $db->setQuery($q);
        $currency_code_3 = $db->loadResult();
		if (!class_exists('CurrencyDisplay'))
            require(JPATH_VM_ADMINISTRATOR . DS . 'helpers' . DS . 'currencydisplay.php');
        $paymentCurrency        = CurrencyDisplay::getInstance($method->payment_currency);
        $totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order_info['details']['BT']->order_total, false), 2);
		
		if($totalInPaymentCurrency != $payment['amount']){
		 
		echo "Incorrect amount";
		exit;
		}
				$toSign = 'callback';
$toSign .= '-' . $_POST['status'];
$toSign .= '-' . $_POST['reason'];
$toSign .= '-' . $_POST['amount'];
$toSign .= '-' . $_POST['currency'];
$toSign .= '-' . $_POST['order'];
$toSign .= '-' . $_POST['url'];
$toSign .= '-' . $_POST['wallet'];
$toSign .= '-' . $_POST['method'];
$toSign .= '-' . $_POST['available-for-refund'];
$toSign .= '-' . $_POST['refund-made-amount'];
$toSign .= '-' . $_POST['salt'];
$toSign .= '-' . $this->params->get('command_key');

	    if (strtoupper(md5($toSign)) != $_POST['sign'])
{

    
die('error: check hash');
}	

		if($payment['status']=='20'){
		$order['order_status'] = $method->status_hold;
	
			}
			if($payment['status']=='30'){
		$order['order_status'] = $method->status_canceled;
		 			}
					if($payment['status']=='40'){
					  
		$order['order_status'] = $method->status_success;
		 			}
						if($payment['status']=='50'){
		$order['order_status'] = $method->status_refunded;
		 			}
			$order['virtuemart_order_id'] = $virtuemart_order_id;
            $order['customer_notified']   = 0;
		
		 ob_start();
		$modelOrder->updateStatusForOneOrder ($virtuemart_order_id, $order, TRUE);
		ob_end_clean();
		
	}
	
	function _storeOnpayInternalData($method, $payment, $virtuemart_order_id, $virtuemart_paymentmethod_id)
	{
		$db = JFactory::getDBO();
		$query = 'SHOW COLUMNS FROM `'.$this->_tablename.'`';
		$db->setQuery($query);
		$columns = $db->loadResultArray(0);
		
		$response_fields = array();
		$post_msg = '';
		foreach ($payment as $key => $value) {
			$post_msg .= $key.'='.$value.'<br />';
			$table_key = 'onpay_response_'.$key;
			
			if (in_array($table_key, $columns)) {
				$response_fields[$table_key] = $value;
			}
		}

		$response_fields['payment_name'] = $this->renderPluginName($method);
		$response_fields['onpay_response_raw'] = $post_msg;
		$response_fields['order_number'] = $payment['order'];
		$response_fields['virtuemart_order_id'] = $virtuemart_order_id;
		$response_fields['virtuemart_paymentmethod_id'] = $virtuemart_paymentmethod_id;
		$response_fields['onpay_custom'] = $payment['ext_details'];

		$this->storePSPluginInternalData($response_fields);
	}
	
	function plgVmOnShowOrderBEPayment($virtuemart_order_id, $payment_method_id)
	{
		if (!$this->selectedThisByMethodId($payment_method_id)) {
			return null;
		}

		if (!($payments = $this->getDatasByOrderId($virtuemart_order_id))) {
			return '';
		}

		$html = '<table class="adminlist" width="50%">'."\n";
		$html .= $this->getHtmlHeaderBE();
		$code = 'onpay_response_';
		
		foreach ($payments as $payment) {
			$html .= '<tr class="row1"><td>'.JText::_('PLG_ONPAY_VM2_DATE').'</td><td align="left">'.$payment->created_on.'</td></tr>';

			foreach ($payment as $key => $value) {
				if (substr($key, 0, strlen($code)) == $code) {
					$html .= $this->getHtmlRowBE($key, $value);
				}
			}
		}
		
		$html .= '</table>'."\n";
		
		return $html;
	}

	function _getMerchantID($method)
	{
		return $method->merchant_id;
	}
	
	function _getSecretWord($method)
	{
		return $method->secret_word;
    }
	
	function _getPaymentResponseHtml($paymentTable, $payment_name)
	{
		VmConfig::loadJLang('com_virtuemart');
		
		$html = '<table>'."\n";
		$html .= $this->getHtmlRow('PLG_ONPAY_VM2_PAYMENT_NAME', $payment_name);
		
		if (!empty($paymentTable)) {
	    	$html .= $this->getHtmlRow('PLG_ONPAY_VM2_ORDER_NUMBER', $paymentTable->order_number);
		}
		
		$html .= '</table>'."\n";

		return $html;
	}

    protected function checkConditions($cart, $method, $cart_prices)
	{
		$this->convert_condition_amount($method);
		$amount = $this->getCartAmount($cart_prices);
		$address = $cart->ST == 0 ? $cart->BT : $cart->ST;

		$amount_cond = ($amount >= $method->min_amount AND $amount <= $method->max_amount OR ($method->min_amount <= $amount AND ($method->max_amount == 0)));
		$countries = array();
	
		if (!empty($method->countries)) {
	    	if (!is_array($method->countries)) {
				$countries[0] = $method->countries;
			} else {
				$countries = $method->countries;
			}
		}

		if (!is_array($address)) {
	    	$address = array();
	    	$address['virtuemart_country_id'] = 0;
		}

		if (!isset($address['virtuemart_country_id'])) {
	    	$address['virtuemart_country_id'] = 0;
		}
		
		if (in_array($address['virtuemart_country_id'], $countries) || count($countries) == 0) {
	    	if ($amount_cond) {
				return true;
			}
		}

		return false;
	}
	
	//функция переводит число в нужный формат
	function to_float($sum)
	{ 
		$sum = round(floatval($sum), 2);
		$sum = sprintf('%01.2f', $sum);
		
		if (substr($sum, -1) == '0') {
			$sum = sprintf('%01.1f', $sum);
		}
		
		return $sum;
	}
	
	function getCosts(VirtueMartCart $cart, $method, $cart_prices)
	{
		if (preg_match('/%$/', $method->cost_percent_total)) {
	    	$cost_percent_total = substr($method->cost_percent_total, 0, -1);
		} else {
	    	$cost_percent_total = $method->cost_percent_total;
		}

		return $method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01);
    }

	function plgVmOnStoreInstallPaymentPluginTable($jplugin_id)
	{
		return $this->onStoreInstallPluginTable($jplugin_id);
    }

    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart)
	{
		return $this->OnSelectCheck($cart);
    }

    public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, $htmlIn)
	{
		return $this->displayListFE($cart, $selected, $htmlIn);
    }

    public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array $cart_prices, $cart_prices_name)
	{
		return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
    }

    function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array())
	{
		return $this->onCheckAutomaticSelected($cart, $cart_prices);
    }

    public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name)
	{
		$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
    }

	function plgVmonShowOrderPrintPayment($order_number, $method_id)
	{
		return $this->onShowOrderPrint($order_number, $method_id);
    }

	function plgVmDeclarePluginParamsPayment($name, $id, $data)
	{
		return $this->declarePluginParams('payment', $name, $id, $data);
    }

    function plgVmSetOnTablePluginParamsPayment($name, $id, $table)
	{
		return $this->setOnTablePluginParams($name, $id, $table);
    }
}